//////////////////////////////////////////////////////////////////////////////
// Filename:          C:\edk_user_repository\MyProcessorIPLib/drivers/asap_config_v1_00_a/src/asap_config.h
// Version:           1.00.a
// Description:       asap_config Driver Header File
// Date:              Thu Jul 17 22:13:36 2008 (by Create and Import Peripheral Wizard)
//////////////////////////////////////////////////////////////////////////////

#ifndef ASAP_CONFIG_H
#define ASAP_CONFIG_H

/***************************** Include Files *******************************/

#include "xbasic_types.h"
#include "xstatus.h"
#include "xio.h"

/************************** Constant Definitions ***************************/


/**
 * User Logic Slave Space Offsets
 * -- SLV_REG0 : user logic slave module register 0
 * -- SLV_REG1 : user logic slave module register 1
 * -- SLV_REG2 : user logic slave module register 2
 * -- SLV_REG3 : user logic slave module register 3
 * -- SLV_REG4 : user logic slave module register 4
 * -- SLV_REG5 : user logic slave module register 5
 * -- SLV_REG6 : user logic slave module register 6
 * -- SLV_REG7 : user logic slave module register 7
 */
#define ASAP_CONFIG_USER_SLV_SPACE_OFFSET (0x00000000)
#define ASAP_CONFIG_SLV_REG0_OFFSET (ASAP_CONFIG_USER_SLV_SPACE_OFFSET + 0x00000000)
#define ASAP_CONFIG_SLV_REG1_OFFSET (ASAP_CONFIG_USER_SLV_SPACE_OFFSET + 0x00000004)
#define ASAP_CONFIG_SLV_REG2_OFFSET (ASAP_CONFIG_USER_SLV_SPACE_OFFSET + 0x00000008)
#define ASAP_CONFIG_SLV_REG3_OFFSET (ASAP_CONFIG_USER_SLV_SPACE_OFFSET + 0x0000000C)
#define ASAP_CONFIG_SLV_REG4_OFFSET (ASAP_CONFIG_USER_SLV_SPACE_OFFSET + 0x00000010)
#define ASAP_CONFIG_SLV_REG5_OFFSET (ASAP_CONFIG_USER_SLV_SPACE_OFFSET + 0x00000014)
#define ASAP_CONFIG_SLV_REG6_OFFSET (ASAP_CONFIG_USER_SLV_SPACE_OFFSET + 0x00000018)
#define ASAP_CONFIG_SLV_REG7_OFFSET (ASAP_CONFIG_USER_SLV_SPACE_OFFSET + 0x0000001C)

/**************************** Type Definitions *****************************/


/***************** Macros (Inline Functions) Definitions *******************/

/**
 *
 * Write a value to a ASAP_CONFIG register. A 32 bit write is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is written.
 *
 * @param   BaseAddress is the base address of the ASAP_CONFIG device.
 * @param   RegOffset is the register offset from the base to write to.
 * @param   Data is the data written to the register.
 *
 * @return  None.
 *
 * @note
 * C-style signature:
 * 	void ASAP_CONFIG_mWriteReg(Xuint32 BaseAddress, unsigned RegOffset, Xuint32 Data)
 *
 */
#define ASAP_CONFIG_mWriteReg(BaseAddress, RegOffset, Data) \
 	XIo_Out32((BaseAddress) + (RegOffset), (Xuint32)(Data))

/**
 *
 * Read a value from a ASAP_CONFIG register. A 32 bit read is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is read from the register. The most significant data
 * will be read as 0.
 *
 * @param   BaseAddress is the base address of the ASAP_CONFIG device.
 * @param   RegOffset is the register offset from the base to write to.
 *
 * @return  Data is the data from the register.
 *
 * @note
 * C-style signature:
 * 	Xuint32 ASAP_CONFIG_mReadReg(Xuint32 BaseAddress, unsigned RegOffset)
 *
 */
#define ASAP_CONFIG_mReadReg(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (RegOffset))


/**
 *
 * Write/Read 32 bit value to/from ASAP_CONFIG user logic slave registers.
 *
 * @param   BaseAddress is the base address of the ASAP_CONFIG device.
 * @param   RegOffset is the offset from the slave register to write to or read from.
 * @param   Value is the data written to the register.
 *
 * @return  Data is the data from the user logic slave register.
 *
 * @note
 * C-style signature:
 * 	void ASAP_CONFIG_mWriteSlaveRegn(Xuint32 BaseAddress, unsigned RegOffset, Xuint32 Value)
 * 	Xuint32 ASAP_CONFIG_mReadSlaveRegn(Xuint32 BaseAddress, unsigned RegOffset)
 *
 */
#define ASAP_CONFIG_mWriteSlaveReg0(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (ASAP_CONFIG_SLV_REG0_OFFSET) + (RegOffset), (Xuint32)(Value))
#define ASAP_CONFIG_mWriteSlaveReg1(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (ASAP_CONFIG_SLV_REG1_OFFSET) + (RegOffset), (Xuint32)(Value))
#define ASAP_CONFIG_mWriteSlaveReg2(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (ASAP_CONFIG_SLV_REG2_OFFSET) + (RegOffset), (Xuint32)(Value))
#define ASAP_CONFIG_mWriteSlaveReg3(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (ASAP_CONFIG_SLV_REG3_OFFSET) + (RegOffset), (Xuint32)(Value))
#define ASAP_CONFIG_mWriteSlaveReg4(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (ASAP_CONFIG_SLV_REG4_OFFSET) + (RegOffset), (Xuint32)(Value))
#define ASAP_CONFIG_mWriteSlaveReg5(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (ASAP_CONFIG_SLV_REG5_OFFSET) + (RegOffset), (Xuint32)(Value))
#define ASAP_CONFIG_mWriteSlaveReg6(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (ASAP_CONFIG_SLV_REG6_OFFSET) + (RegOffset), (Xuint32)(Value))
#define ASAP_CONFIG_mWriteSlaveReg7(BaseAddress, RegOffset, Value) \
 	XIo_Out32((BaseAddress) + (ASAP_CONFIG_SLV_REG7_OFFSET) + (RegOffset), (Xuint32)(Value))

#define ASAP_CONFIG_mReadSlaveReg0(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (ASAP_CONFIG_SLV_REG0_OFFSET) + (RegOffset))
#define ASAP_CONFIG_mReadSlaveReg1(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (ASAP_CONFIG_SLV_REG1_OFFSET) + (RegOffset))
#define ASAP_CONFIG_mReadSlaveReg2(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (ASAP_CONFIG_SLV_REG2_OFFSET) + (RegOffset))
#define ASAP_CONFIG_mReadSlaveReg3(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (ASAP_CONFIG_SLV_REG3_OFFSET) + (RegOffset))
#define ASAP_CONFIG_mReadSlaveReg4(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (ASAP_CONFIG_SLV_REG4_OFFSET) + (RegOffset))
#define ASAP_CONFIG_mReadSlaveReg5(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (ASAP_CONFIG_SLV_REG5_OFFSET) + (RegOffset))
#define ASAP_CONFIG_mReadSlaveReg6(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (ASAP_CONFIG_SLV_REG6_OFFSET) + (RegOffset))
#define ASAP_CONFIG_mReadSlaveReg7(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (ASAP_CONFIG_SLV_REG7_OFFSET) + (RegOffset))

/************************** Function Prototypes ****************************/


/**
 *
 * Run a self-test on the driver/device. Note this may be a destructive test if
 * resets of the device are performed.
 *
 * If the hardware system is not built correctly, this function may never
 * return to the caller.
 *
 * @param   baseaddr_p is the base address of the ASAP_CONFIG instance to be worked on.
 *
 * @return
 *
 *    - XST_SUCCESS   if all self-test code passed
 *    - XST_FAILURE   if any self-test code failed
 *
 * @note    Caching must be turned off for this function to work.
 * @note    Self test may fail if data memory and device are not on the same bus.
 *
 */
XStatus ASAP_CONFIG_SelfTest(void * baseaddr_p);

#endif // ASAP_CONFIG_H
