/*********************************************************************

 single_pulse.v module

**********************************************************************

	  		     CONFIDENTIAL

 Copyright (C) 2003, 2004, Regents of the University of California,

 The information contained herein is the exclusive property
 of the VCL group and shall not be distributed, reproduced,
 or disclosed in whole or in part without prior written 
 permission of VCL.

 This work has been developed by members of the VLSI Computation Lab
 (VCL) in the Department of Electrical and Computer Engineering at
 the University of California at Davis. Contact: bbaas@ece.ucdavis.edu

**********************************************************************

 created on:	08/27/2005 
 created by:	Jeremy W. Webb
 last edit on:	08/27/2005 
 last edit by:	Jeremy W. Webb
 revision:	001
 comments:	Created

**********************************************************************
 AsAP Version 1 Test Board (ET42001)


 This module generates a single pulse when triggered by a 
 positive edge.
         
**********************************************************************/

module single_pulse (pulse,
                    trigger, clk, rst);

input   trigger, clk, rst;
output  pulse;
reg     pulse;
reg     first_pulse;

wire    new_rst;

assign new_rst = rst | pulse;

//always @ (posedge trigger or posedge rst or posedge pulse)
always @ (posedge trigger or posedge new_rst)
    if (new_rst) first_pulse <= 0;
    else first_pulse <= ~first_pulse;

always @ (posedge clk or posedge rst)
    if (rst) pulse <= 0;
    else pulse <= first_pulse;

endmodule
/*
// *** Instantiate the Single Pulse module ***
single_pulse    single_pulse   (.pulse (pulse),
                                .trigger (trigger),
                                .clk (clk),
                                .rst (rst));


*/

